/*
 * a1.y.c
 * Copyright (C) 2007-2011, 2013, 2014, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <a1-inter.h>
#include <a1-types.h>
#include <e4.h>

#define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))

extern const char *const x1f4_c1_empty_string;

int
_x1f4_a1_slip_text(void *context, struct a1_link_type *link_data, void *used)
{
    X1f4_E4_C_TEXT text;
    int status;
    struct a1_shuffle_type *shuffle_data;

    shuffle_data = context;

    text = I_TEXT((char *) used + (integral_q) link_data->datatext.link);

    if (text == x1f4_c1_empty_string) {
	status = 0;
    } else {
	status = shuffle_data->m.free(shuffle_data->m.data, text);
	if (status) {
	    status = _x1f4_a1_stat_free(shuffle_data);
	}
    }

    return status;
}
