/*
 * c12nd.e.c
 * Copyright (C) 2011-2013, 2015, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <c1-inter.h>
#include <c1-types.h>
#include <er.h>
#include <exerrors.h>

#define program(program) \
    ((struct c1_program_type *) (program))

int
_x1f4_c1_stat_free(void *program)
{
    LINE_EEER(program(program)->x);

    PUSH_DATA("cannot free memory", 18);

    POST_EEER();

    return X1f4_EX_CRITICAL;
}


int
_x1f4_c1_stat_link(void *program)
{
    LINE_EEER(program(program)->x);

    PUSH_DATA("cannot allocate memory", 22);

    POST_EEER();

    return X1f4_EX_CANNOT_CONTINUE;
}


int
_x1f4_c1_stat_miss(void *program)
{
    LINE_EEER(program(program)->x);

    PUSH_DATA("unset function pointer", 22);

    POST_EEER();

    return X1f4_EX_CAN_CONTINUE;
}
