/*
 * lxcall-e.i.c
 * Copyright (C) 2011-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <frame.h>
#include <lxcall-inter.h>
#include <track.h>
#include <trans.h>

int
_libx1f4i0_lxcall_pick_call(void **input,
			    const struct x1f4_function_type *function_data,
			    unsigned offset,
			    struct x1f4_frame_type *frame_data,
			    struct x1f4_track_type *track_data,
			    struct x1f4_linetext_type **linetext)
{
    int status;
    struct x1f4_linetext_type *linetext_data;
    struct x1f4_trans_type trans;

    linetext_data = *linetext;

    trans.data = frame_data->data;
    trans.link = frame_data->link;

    status = _libx1f4i0_lxcall_lock_call
	(function_data, offset, &trans, track_data, &linetext_data);
    if (status) {
    } else {
	void **used;

	linetext_data->function.flags &=
	    ~(X1f4_E4_SIDE_LIST | X1f4_E4_SLIP_LIST);

	used = input[-1];

	used[X1f4_E4_RENDITION] = &linetext_data->function;
    }

    return status;
}
