/*
 * lxcall-y.e.c
 * Copyright (C) 2008-2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxcall-types.h>
#include <nt.h>

void
_libx1f4i0_lxcall_line_emix(v_case_args_____1, int norm, int call, int post,
			    int (*const *rate)(void *, void *, void **))
{
    int *line, type;
    unsigned chase = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK, flags, white =
	X1f4_E4_POST_XSET;

    flags = nodetype_data->flags;

    type = nodetype_data->code;

    if (flags & X1f4_LX_FLAT_REFLEX) {
    } else {
	chase |= X1f4_E4_POST_TYPE;
    }

    if (nodetype_data->push) {
	if (flags & X1f4_LX_FLAT_REFLEX) {
	} else {
	    white |= X1f4_E4_POST_FLAT;
	}

	linetext_data->function.function = rate[5];
    } else {
	if (X1f4_E4_LAST < type) {
	    linetext_data->function.function = rate[4];
	} else {
	    if (type == X1f4_E4_TEXT) {
		linetext_data->function.function = rate[3];
	    } else {
		if (type == X1f4_E4_REAL) {
		    linetext_data->function.function = rate[2];
		} else {
		    if (type == X1f4_E4_MODE) {
			linetext_data->function.function = rate[1];
		    } else {
			if (type == X1f4_E4_BILL) {
			    linetext_data->function.function = rate[0];
			} else {
			}
		    }
		}
	    }
	}
    }

    line = *args;

    linetext_data->function.args = line;

    *line++ = type;
    *line++ = norm;
    *line++ = call;
    if (flags & X1f4_LX_FLAT_REFLEX) {
    } else {
	*line++ = white;
	*line++ = 0;
	*line++ = 0;
    }

    *args = line;

    linetext_data->function.type = ~post ? post : type;

    linetext_data->function.flags = chase;
}
