/*
 * lxcase-a.0.c
 * Copyright (C) 2008-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4-m.0.h>
#include <e4.h>
#include <lxcase-defs.h>
#include <lxcase-inter.h>
#include <lxcase-types.h>

#define MAKE_SINGLE(a, b)		a

#define c_____m__			c_____m_m
#define c_____t__			c_____t_t

#define nonsense_160312_0		_libx1f4i0_lxcase_i160312_0
#define nonsense_160312_1		_libx1f4i0_lxcase_i160312_1
#define nonsense_160312_2		_libx1f4i0_lxcase_i160312_2
#define nonsense_160312_3		_libx1f4i0_lxcase_i160312_3
#define nonsense_160312_4		_libx1f4i0_lxcase_i160312_4
#define nonsense_160313_0		_libx1f4i0_lxcase_i160313_0
#define nonsense_160314_0		_libx1f4i0_lxcase_i160314_0
#define nonsense_160725_0		_libx1f4i0_lxcase_i160725_0
#define nonsense_160725_1		_libx1f4i0_lxcase_i160725_1
#define nonsense_160725_2		_libx1f4i0_lxcase_i160725_2
#define nonsense_160727_0		_libx1f4i0_lxcase_i160727_0
#define nonsense_160727_1		_libx1f4i0_lxcase_i160727_1
#define nonsense_160811_0		_libx1f4i0_lxcase_i160811_0
#define nonsense_160811_1		_libx1f4i0_lxcase_i160811_1

#define size_f() \
    sizeof(text_f) / sizeof(struct x1f4_function_type)

static int init_text(struct lxcase_type *, unsigned,
		     const struct screen_type *);
static int line_text(struct lxcase_type *, struct x1f4_linetext_type *);
static int link_text(struct lxcase_type *, unsigned,
		     const struct screen_type *);

static const int c_____m_m[] = {
/* *INDENT-OFF* */
    X1f4_E4_MODE,
    X1f4_E4_MODE
/* *INDENT-ON* */
}, c_____t_m[] = {
/* *INDENT-OFF* */
    X1f4_E4_TEXT,
    X1f4_E4_MODE
/* *INDENT-ON* */
}, c_____t_t[] = {
/* *INDENT-OFF* */
    X1f4_E4_TEXT,
    X1f4_E4_TEXT
/* *INDENT-ON* */
}, c___t_m_m[] = {
/* *INDENT-OFF* */
    X1f4_E4_TEXT,
    X1f4_E4_MODE,
    X1f4_E4_MODE
/* *INDENT-ON* */
};

static const struct x1f4_function_type text_f[] = {
/* *INDENT-OFF* */
    {	"chdir",		nonsense_160312_1,
	X1f4_E4_VOID,		c_____t__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,	5			},
    {	"chmod",		nonsense_160725_1,
	X1f4_E4_VOID,		c_____t_m,	2,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,	5			},
    {	"chown",		nonsense_160725_2,
	X1f4_E4_VOID,		c___t_m_m,	3,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,	5			},
    {	"getpid",		nonsense_160727_0,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL,			6			},
    {	"getppid",		nonsense_160727_1,
	X1f4_E4_MODE,		NULL,		0,
	X1f4_E4_KEEP_CALL,			7			},
    {	"kill",			nonsense_160313_0,
	X1f4_E4_VOID,		c_____m_m,	2,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,	4			},
    {	"mkdir",		nonsense_160312_0,
	X1f4_E4_VOID,		c_____t_m,	2,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,	5			},
    {	"raise",		nonsense_160725_0,
	X1f4_E4_VOID,		c_____m__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,	5			},
    {	"remove",		nonsense_160312_4,
	X1f4_E4_VOID,		c_____t__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,	6			},
    {	"rename",		nonsense_160314_0,
	X1f4_E4_VOID,		c_____t_t,	2,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,	6			},
    {	"rmdir",		nonsense_160312_2,
	X1f4_E4_VOID,		c_____t__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,	5			},
    {	"sleep",		nonsense_160811_0,
	X1f4_E4_VOID,		c_____m__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,	5			},
    {	"unlink",		nonsense_160312_3,
	X1f4_E4_VOID,		c_____t__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,	6			},
    {	"usleep",		nonsense_160811_1,
	X1f4_E4_VOID,		c_____m__,	1,
	X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,	6			},
    {	NULL,			NULL,
	0,			NULL,		0,
	0,					1			}
/* *INDENT-ON* */
};

static int
init_text(struct lxcase_type *lxcase_data, unsigned bits,
	  const struct screen_type *screen_data)
{
    int status;

    if (bits & CODELINK_LINK) {
	lxcase_data->link_w = screen_data->lock_w;
    } else {
	lxcase_data->link_w.data = NULL;
	lxcase_data->link_w.free = _x1f4_e4_free_data;
	lxcase_data->link_w.link = _x1f4_e4_link_data;
	lxcase_data->link_w.mode = _x1f4_e4_mode_data;
    }

    if (bits & RESOURCE_LINK) {
	lxcase_data->link_m = screen_data->lock_m;
    } else {
	lxcase_data->link_m.data = NULL;
	lxcase_data->link_m.free = _x1f4_e4_free_data;
	lxcase_data->link_m.link = _x1f4_e4_link_data;
	lxcase_data->link_m.mode = _x1f4_e4_mode_data;
    }

    if (1) {
	lxcase_data->link_v = screen_data->lock_v;
    }

    if (bits & TEXTFLAT_LINK) {
	lxcase_data->link_e = screen_data->lock_e;
    } else {
	lxcase_data->link_e.data = NULL;
	lxcase_data->link_e.line = NULL;
	lxcase_data->link_e.post = NULL;
	lxcase_data->link_e.push = NULL;
    }

    status = link_text(lxcase_data, bits, screen_data);

    return status;
}


static int
line_text(struct lxcase_type *lxcase_data,
	  struct x1f4_linetext_type *linetext_data)
{
    const struct x1f4_function_type *function_data;
    unsigned i;

    function_data = text_f;
    i = size_f();
    i--;
    for (; i; i--) {
	linetext_data->context = lxcase_data;
	linetext_data->function = *function_data;
	linetext_data++;
	function_data++;
    }
    {
	linetext_data->context = NULL;
	linetext_data->function = *function_data;
    }

    return 0;
}


static int
link_text(struct lxcase_type *lxcase_data, unsigned bits,
	  const struct screen_type *screen_data)
{
    int status;
    void *data;

    status = lxcase_data->link_w.link
	(lxcase_data->link_w.data, &data,
	 size_f() * sizeof(struct x1f4_linetext_type));
    if (status) {
	status = LINK_ERROR;
    } else {
	line_text(lxcase_data, data);

	lxcase_data->link_f.data = data;
    }

    return status;
}


int
x1f4_init_lxcase(void **lxcase, unsigned bits,
	         const struct screen_type *screen_data)
{
    int (*link) (void *, void **, unsigned), status;
    void *data, *text;

    if (bits & CODELINK_LINK) {
	data = screen_data->lock_w.data;
	link = screen_data->lock_w.link;
    } else {
	data = (void *) 0;
	link = _x1f4_e4_link_data;
    }

    status = link(data, &text, sizeof(struct lxcase_type));
    if (status) {
	status = LINK_ERROR;
    } else {
	status = init_text(text, bits, screen_data);
	if (status) {
	    if (bits & CODELINK_LINK) {
		screen_data->lock_w.free(data, text);
	    } else {
		_x1f4_e4_free_data(data, text);
	    }
	} else {
	    *lxcase = text;
	}
    }

    return status;
}
