/*
 * lxcase-types.h
 * Copyright (C) 2008-2012, 2014-2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxcase_types_H__
#define __LIBx1f4_lxcase_types_H__

#include <config.h>

#include <frame.h>
#include <lxlock.h>
#include <track.h>
#include <trans.h>

typedef struct lxcase_type {
    struct lxlock_type ever_a;
    struct {
	void *data;
    } link_f;
} lxcase_type;

typedef struct screen_type {
    struct x1f4_track_type lock_e;
    struct x1f4_trans_type lock_m;
    struct x1f4_frame_type lock_v;
    struct x1f4_trans_type lock_w;
} screen_type;

#endif				/* __LIBx1f4_lxcase_types_H__ */
