/*
 * lxdash-d.r.c
 * Copyright (C) 2008-2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <copy.h>
#include <d_fset.h>
#include <e4.h>
#include <lxcast.h>
#include <lxdash-close.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>
#include <nt.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))
#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_USER(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxdash_r_derived(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;
    struct effect_type effect;
    struct lxdash_type *lxdash_data;
    void *data;

    dxdash_data = I_LINE(input[0]);

    lxdash_data = context;

    effect.mode = I_MODE(input[1]);

    status = x1f4_find_lxfset(dxdash_data->dash, &effect, &data);
    if (status) {
	int type;
	struct lxtext_type *lxtext_data, *lxtext_link;
	struct x1f4_dxcast_type *dxcast_data;
	unsigned miss;

	status = 0;

	dxcast_data = I_USER(input[2]);

	type = dxcast_data->type;

	lxtext_link = lxdash_data->link_f.text;

	lxtext_data = lxtext_link;

	close_frame(miss, lxtext_data);

	do {
	    int (*copy)(void *, void *, void **, const void *,
			const struct x1f4_nodelink_type *);
	    struct effect_type *effect_data;
	    void *side;

	    if (miss) {
		copy = lxtext_data->lxtype.copy;
		if (copy) {
		    status = copy
			(lxtext_data->lxtype.context, NULL,
			 &side, I_USER(&dxcast_data->data),
			 lock_excase(dxdash_data));
		    if (status) {
			break;
		    }
		}
	    } else {
		copy = NULL;
	    }

	    effect_data = data;

	    if (0) {
	    } else {
		if (1) {
		    unsigned link;

		    link = effect_data->link;

		    if (~link) {
			int (*free)(void *, void *, struct excase_type **,
				    const struct excase_type *);
			struct lxtext_type *lxtext_slip;

			lxtext_slip = lxtext_link + link;

			free = lxtext_slip->lxtype.free;
			if (free) {
			    status = free
				(lxtext_slip->lxtype.context,
				 I_USER(&effect_data->fxdata), NULL,
				 lock_excase(dxdash_data));
			}
		    }
		}

		{
		    unsigned link;

		    effect_data->type = type;

		    link = miss ? lxtext_data - lxtext_link : ~0;

		    effect_data->link = link;

		    if (copy) {
			l_USER(side, &effect_data->fxdata);
		    } else {
			copy_miss(&effect_data->fxdata, type,
				  &dxcast_data->data);
		    }
		}
	    }
	} while (0);
    } else {
	status = _libx1f4i0_lxdash_stat_miss(lxdash_data, effect.mode);
    }

    return status;
}
