/*
 * lxdash-r.g.0.c
 * Copyright (C) 2008-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_REAL(t)			(*((X1f4_E4_C_REAL *) (t)))

#define l_REAL(e, output) \
    {									      \
	X1f4_E4_C_REAL *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxdash_g0class_r(void *context, void *output, void **input)
{
    int status;
    struct cxbend_type *cxbend_data;
    struct dxdash_type *dxdash_data;
    void *data;

    cxbend_data = context;

    dxdash_data = I_LINE(input[1]);

    status = cxbend_data->pick(dxdash_data->dash, &data);
    if (status) {
	status = _libx1f4i0_lxdash_stat_line(cxbend_data->line, 0, status);
    } else {
	struct effect_type *effect_data;
	unsigned type;

	effect_data = data;

	type = effect_data->type;
	if (type != X1f4_E4_REAL) {
	    status = _libx1f4i0_lxdash_stat_ends
		(cxbend_data->line, cxbend_data->bend, type, X1f4_E4_REAL);
	} else {
	    X1f4_E4_C_REAL real;

	    real = I_REAL(&effect_data->fxdata);
	    l_REAL(real, input[0]);
	    l_REAL(real, output);
	}
    }

    return status;
}
