/*
 * lxdash-u.g.b.c
 * Copyright (C) 2008-2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <e4.h>
#include <lxcall.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_USER(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxdash_gbclass_u(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;
    struct lxtext_type *lxtext_data;
    void *data;

    lxtext_data = context;

    dxdash_data = I_LINE(input[1]);

    status = _libx1f4i0_ever_lxfset(dxdash_data->dash, &data);
    if (status) {
	status = _libx1f4i0_lxdash_stat_line(lxtext_data->text, 0, status);
    } else {
	struct effect_type *effect_data;
	unsigned type;

	effect_data = data;

	type = effect_data->type;
	if (type != lxtext_data->lxtype.code) {
	    status = _libx1f4i0_lxdash_stat_ends
		(lxtext_data->text, 1, type, lxtext_data->lxtype.code);
	} else {
            X1f4_E4_C_USER user;

            user = I_USER(&effect_data->fxdata);
            if (lxtext_data->lxtype.copy && lxtext_data->lxtype.push) {
                status = _libx1f4i0_lxcall_side_node
                    (&lxtext_data->lxtype, user, input[0]);
                if (status) {
                } else {
                    l_USER(I_USER(input[0]), output);
                }
            } else {
                l_USER(user, input[0]);
                l_USER(user, output);
            }
	}
    }

    return status;
}
