/*
 * lxdash-u.q.f.c
 * Copyright (C) 2008-2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <e4.h>
#include <lxcall.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_USER(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

#define lxtext(delete)			((struct lxtext_type *) (delete))

int
_libx1f4i0_lxdash_qfclass_u(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;
    void *data;

    dxdash_data = I_LINE(input[0]);

    status = _libx1f4i0_lead_lxfset(dxdash_data->dash, &data);
    if (status) {
	status = _libx1f4i0_lxdash_stat_line
	    (lxtext(context)->text, 0, status);
    } else {
	struct effect_type *effect_data;
	struct lxtext_type *lxtext_data;
	unsigned type;

	effect_data = data;

	lxtext_data = context;

	type = effect_data->type;
	if (type != lxtext_data->lxtype.code) {
	    status = _libx1f4i0_lxdash_stat_ends
		(lxtext_data->text, 0, type, lxtext_data->lxtype.code);
	} else {
	    if (lxtext_data->lxtype.copy && lxtext_data->lxtype.push) {
		status = _libx1f4i0_lxcall_pass_node
		    (&lxtext_data->lxtype, I_USER(&effect_data->fxdata),
		     output);
	    } else {
		l_USER(I_USER(&effect_data->fxdata), output);
	    }
	}
    }

    return status;
}
