/*
 * lxdate-inter.h
 * Copyright (C) 2008-2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxdate_inter_H__
#define __LIBx1f4_lxdate_inter_H__

#include <dt.h>
#include <e4.h>
#include <lxdate-types.h>
#include <lxwide.h>
#include <nt.h>

#define _libx1f4i0_lxdate_bset_date	x1f4_bset_lxdate
#define _libx1f4i0_lxdate_clip_date	x1f4_clip_lxdate
#define _libx1f4i0_lxdate_copy_date	x1f4_copy_lxdate
#define _libx1f4i0_lxdate_copy_time	x1f4_copy_lxtime
#define _libx1f4i0_lxdate_dset_date	x1f4_dset_lxdate
#define _libx1f4i0_lxdate_fini_date	x1f4_fini_lxdate
#define _libx1f4i0_lxdate_flat_date	x1f4_flat_lxdate
#define _libx1f4i0_lxdate_flat_time	x1f4_flat_lxtime
#define _libx1f4i0_lxdate_free_date	x1f4_free_lxdate
#define _libx1f4i0_lxdate_free_time	x1f4_free_lxtime
#define _libx1f4i0_lxdate_fset_date	x1f4_fset_lxdate
#define _libx1f4i0_lxdate_init_date	x1f4_init_lxdate
#define _libx1f4i0_lxdate_lead_date	x1f4_lead_lxdate
#define _libx1f4i0_lxdate_lead_time	x1f4_lead_lxtime
#define _libx1f4i0_lxdate_line_date	x1f4_line_lxdate
#define _libx1f4i0_lxdate_line_time	x1f4_line_lxtime
#define _libx1f4i0_lxdate_link_date	x1f4_link_lxdate
#define _libx1f4i0_lxdate_link_time	x1f4_link_lxtime
#define _libx1f4i0_lxdate_near_date	x1f4_near_lxdate
#define _libx1f4i0_lxdate_node_date	x1f4_node_lxdate
#define _libx1f4i0_lxdate_node_time	x1f4_node_lxtime
#define _libx1f4i0_lxdate_push_date	x1f4_push_lxdate
#define _libx1f4i0_lxdate_push_time	x1f4_push_lxtime
#define _libx1f4i0_lxdate_seek_date	x1f4_seek_lxdate
#define _libx1f4i0_lxdate_slip_date	x1f4_slip_lxdate
#define _libx1f4i0_lxdate_slip_time	x1f4_slip_lxtime
#define _libx1f4i0_lxdate_tile_date	x1f4_tile_lxdate
#define _libx1f4i0_lxdate_type_date	x1f4_type_lxdate
#define _libx1f4i0_lxdate_type_time	x1f4_type_lxtime

#define __types_long(lxdate) \
    (&((struct lxdate_type *) (lxdate))->ever_a)

#define _libx1f4i0_lxdate_stat_free(___l, ___1) \
    _libx1f4i0_lxlock_stat_free(__types_long((___l)), (___1))
#define _libx1f4i0_lxdate_stat_link(___l) \
    _libx1f4i0_lxlock_stat_link(__types_long((___l)))
#define _libx1f4i0_lxdate_stat_mode(___l) \
    _libx1f4i0_lxlock_stat_mode(__types_long((___l)))

extern int _libx1f4i0_lxdate_0_logique(void *, void *, void **);
extern int _libx1f4i0_lxdate_0_absence(void *, void *, void **);
extern int _libx1f4i0_lxdate_1_logique(void *, void *, void **);
extern int _libx1f4i0_lxdate_1_absence(void *, void *, void **);
extern int _libx1f4i0_lxdate_2_logique(void *, void *, void **);
extern int _libx1f4i0_lxdate_2_absence(void *, void *, void **);
extern int _libx1f4i0_lxdate_3_logique(void *, void *, void **);
extern int _libx1f4i0_lxdate_3_pending(void *, void *, void **);
extern int _libx1f4i0_lxdate_4_logique(void *, void *, void **);
extern int _libx1f4i0_lxdate_5_logique(void *, void *, void **);
extern int _libx1f4i0_lxdate_6_logique(void *, void *, void **);
extern int _libx1f4i0_lxdate_7_logique(void *, void *, void **);
extern int _libx1f4i0_lxdate_a_logique(void *, void *, void **);
extern int _libx1f4i0_lxdate_bset_date
    (void *, const struct x1f4_operator_type **);
extern int _libx1f4i0_lxdate_c_forward(void *, void *, void **);
extern int _libx1f4i0_lxdate_c_logique(void *, void *, void **);
extern int _libx1f4i0_lxdate_clip_date
    (unsigned, const void *, struct x1f4_nodetype_type **, int *);
extern int _libx1f4i0_lxdate_copy_date
    (void *, void *, void **, const void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxdate_copy_time
    (void *, void *, void **, const void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxdate_dset_date
    (void *, const struct x1f4_datatype_type **);
extern int _libx1f4i0_lxdate_f_absence(void *, void *, void **);
extern int _libx1f4i0_lxdate_f_logique(void *, void *, void **);
extern int _libx1f4i0_lxdate_f_pending(void *, void *, void **);
extern int _libx1f4i0_lxdate_fini_date(void **);
extern int _libx1f4i0_lxdate_flat_date(void *, void **);
extern int _libx1f4i0_lxdate_flat_time(void *, void **);
extern int _libx1f4i0_lxdate_free_date
    (void *, void *, struct x1f4_nodelink_type **,
     const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxdate_free_time
    (void *, void *, struct x1f4_nodelink_type **,
     const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxdate_fset_date
    (void *, const struct x1f4_linetext_type **);
extern int _libx1f4i0_lxdate_init_date
    (void **, unsigned, const struct screen_type *);
extern int _libx1f4i0_lxdate_lead_date(void *, void **);
extern int _libx1f4i0_lxdate_lead_time(void *, void **);
extern int _libx1f4i0_lxdate_line_date(void *, void **);
extern int _libx1f4i0_lxdate_line_time(void *, void **);
extern int _libx1f4i0_lxdate_link_date(void *, void **);
extern int _libx1f4i0_lxdate_link_time(void *, void **);
extern int _libx1f4i0_lxdate_m_absence(void *, void *, void **);
extern int _libx1f4i0_lxdate_m_logique(void *, void *, void **);
extern int _libx1f4i0_lxdate_n_forward(void *, void *, void **);
extern int _libx1f4i0_lxdate_n_logique(void *, void *, void **);
extern int _libx1f4i0_lxdate_near_date(void *);
extern int _libx1f4i0_lxdate_node_date
    (void *, void **, void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxdate_node_time
    (void *, void **, void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxdate_o_logique(void *, void *, void **);
extern int _libx1f4i0_lxdate_p_logique(void *, void *, void **);
extern int _libx1f4i0_lxdate_r_logique(void *, void *, void **);
extern int _libx1f4i0_lxdate_push_date
    (void *, void **, void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxdate_push_time
    (void *, void **, void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxdate_q_logique(void *, void *, void **);
extern int _libx1f4i0_lxdate_s_forward(void *, void *, void **);
extern int _libx1f4i0_lxdate_s_logique(void *, void *, void **);
extern int _libx1f4i0_lxdate_seek_date(const void *);
extern int _libx1f4i0_lxdate_side_date(void *, void *);
extern int _libx1f4i0_lxdate_side_time(void *, void *);
extern int _libx1f4i0_lxdate_slip_date(void *, void **);
extern int _libx1f4i0_lxdate_slip_time(void *, void **);
extern int _libx1f4i0_lxdate_stat_down(void *);
extern int _libx1f4i0_lxdate_tile_date
    (void **, unsigned, struct x1f4_lxwide_type *, unsigned, const void *);
extern int _libx1f4i0_lxdate_type_date(struct x1f4_nodetype_type *, int);
extern int _libx1f4i0_lxdate_type_time(struct x1f4_nodetype_type *, int);
extern int _libx1f4i0_lxdate_v_logique(void *, void *, void **);
extern int _libx1f4i0_lxdate_x_absence(void *, void *, void **);
extern int _libx1f4i0_lxdate_y_absence(void *, void *, void **);
extern int _libx1f4i0_lxtime_f_pending(void *, void *, void **);
extern int _libx1f4i0_lxtime_c_forward(void *, void *, void **);
extern int _libx1f4i0_lxtime_c_logique(void *, void *, void **);
extern int _libx1f4i0_lxtime_d_logique(void *, void *, void **);
extern int _libx1f4i0_lxtime_n_forward(void *, void *, void **);
extern int _libx1f4i0_lxtime_s_forward(void *, void *, void **);
extern int _libx1f4i0_lxtime_s_logique(void *, void *, void **);

#endif				/* __LIBx1f4_lxfile_inter_H__ */
