/*
 * lxline-c.1.c
 * Copyright (C) 2008-2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <copy.h>
#include <e4.h>
#include <fd.h>
#include <l_note.h>
#include <lxcall.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))
#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

#define byte(miss)			((unsigned char *) (miss))

int
_libx1f4i0_lxline_1_centric(void *context, void *output, void **input)
{
    int status;
    const char *lift;
    struct cxseek_type *cxseek_data;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;
    unsigned size;
    void *data;

    dxline_data = I_LINE(input[1]);

    cxseek_data = context;

    lxline_data = cxseek_data->line;

    status = cxseek_data->seek
	(dxline_data->line, I_TEXT(input[2]), &data, &lift, &size);
    if (status) {
	unsigned call, type;

	type = effect_type(data);
	call = *((struct x1f4_function_type *)
		 ((void **) input[-1])[X1f4_E4_RENDITION])->args;
	if (type != call) {
	    status = _libx1f4i0_lxline_stat_trip
		(lxline_data, lift, size, type, call);
	} else {
	    if (0) {
	    } else {
		unsigned link;

		link = effect_link(data);

		l_MODE(1, output);

		do {
		    if (~link) {
			struct lxtext_type *lxtext_data;

			lxtext_data = lxline_data->link_f.text;
			lxtext_data += link;
			if (lxtext_data->lxtype.lead
			    && lxtext_data->lxtype.slip) {
			    status = _libx1f4i0_lxcall_land_node
				(&lxline_data->link_v, &lxline_data->link_e,
				 &lxtext_data->lxtype, I_USER(byte(data) + 8),
				 input[0]);
			    if (1) {
				break;
			    }
			}

			if (lxtext_data->lxtype.copy
			    && lxtext_data->lxtype.push) {
			    status = _libx1f4i0_lxcall_side_node
				(&lxtext_data->lxtype, I_USER(byte(data) + 8),
				 input[0]);
			    if (1) {
				break;
			    }
			}
		    }

		    status = 0;

		    copy_miss(*input, type, byte(data) + 8);
		} while (0);
	    }
	}
    } else {
	if (0) {
	} else {
	    l_MODE(0, output);
	    if (1) {
		status = 0;
	    }
	}
    }

    return status;
}
