/*
 * lxline-p.e.c
 * Copyright (C) 2008-2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_note.h>
#include <lxline-inter.h>
#include <lxline-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))

static int half_miss(void *, void *);

static int
half_miss(void *miss, void *half)
{
    unsigned *size;

    size = miss;
    (*size)--;

    return 0;
}


int
_libx1f4i0_lxline_e_pending(void *context, void *output, void **input)
{
    int status;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;
    struct x1f4_sfnote_type sfnote;
    void *line, *part;

    dxline_data = I_LINE(input[0]);

    lxline_data = context;

    sfnote.trans = &lxline_data->link_m;

    line = dxline_data->line;

    status = _libx1f4i0_init_sfnote(&part, X1f4_SFNOTE_TRANS_MASK, &sfnote);
    if (status) {
    } else {
	int excess;
	void *half;

	status = _libx1f4i0_init_sfnote
	    (&half, X1f4_SFNOTE_TRANS_MASK, &sfnote);
	if (status) {
	} else {
	    status = _libx1f4i0_tear_sfnote(line, I_TEXT(input[2]), 1, part);
	    if (status) {
	    } else {
		status = _libx1f4i0_tear_sfnote
		    (line, I_TEXT(input[1]), 0, half);
		if (status) {
		} else {
		    status = _libx1f4i0_join_sfnote(line, part);
		    if (status) {
		    } else {
			_libx1f4i0_lime_sfnote
			    (half, &dxline_data->size, half_miss);
		    }
		}
	    }

	    excess = _libx1f4i0_fini_sfnote(&half);
	    if (excess) {
		if (status) {
		} else {
		    status = excess;
		}
	    }
	}

	excess = _libx1f4i0_fini_sfnote(&part);
	if (excess) {
	    if (status) {
	    } else {
		status = excess;
	    }
	}
    }

    if (status) {
	status = _libx1f4i0_lxline_stat_line(lxline_data, 0, status);
    }

    return status;
}
