/*
 * lxline-t.e.0.c
 * Copyright (C) 2008-2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxline-config.h>

#include <e4.h>
#include <lxline-inter.h>
#include <lxline-types.h>
#include <lxnext.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))

#define l_TEXT(e, output) \
    {									      \
	X1f4_E4_C_TEXT *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

#define byte(miss)			((unsigned char *) (miss))

int
_libx1f4i0_lxline_e0class_t(void *context, void *output, void **input)
{
    int status;
    struct cxbend_type *cxbend_data;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;
    void *data;

    cxbend_data = context;

    lxline_data = cxbend_data->line;

    dxline_data = I_LINE(input[1]);

    status = cxbend_data->pick(dxline_data->line, &data);
    if (status) {
	status = _libx1f4i0_lxline_stat_line(lxline_data, 0, status);
    } else {
	unsigned type;

	type = byte(data)[0] << 030 | byte(data)[1] << 020
	    | byte(data)[2] << 010 | byte(data)[3];
	if (type != X1f4_E4_TEXT) {
	    status = _libx1f4i0_lxline_stat_ends
		(lxline_data, cxbend_data->bend, type, X1f4_E4_TEXT);
	} else {
	    status = _libx1f4i0_lxnext_push_text
		(&lxline_data->ever_a, input[0], I_TEXT(byte(data) + 8),
		 lock_excase(dxline_data));
	    if (status) {
	    } else {
		byte(data)[4] = ~0 >> 030;
		byte(data)[5] = ~0 >> 020;
		byte(data)[6] = ~0 >> 010;
		byte(data)[7] = ~0 >> 000;

		status = cxbend_data->slip(dxline_data->line);
		if (status) {
		    status =
			_libx1f4i0_lxline_stat_line(lxline_data, 0, status);
		} else {
		    dxline_data->size--;

		    l_TEXT(I_TEXT(*input), output);
		}
	    }
	}
    }

    return status;
}
