/*
 * lxline-u.j.c
 * Copyright (C) 2008-2014, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_note.h>
#include <lxcall.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

#define l_USER(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

#define byte(miss)			((unsigned char *) (miss))

int
_libx1f4i0_lxline_j_class_u(void *context, void *output, void **input)
{
    int status;
    struct dxline_type *dxline_data;
    struct lxtext_type *lxtext_data;
    void *data;

    lxtext_data = context;

    dxline_data = I_LINE(input[1]);

    status = _libx1f4i0_find_sfnote
	(dxline_data->line, I_TEXT(input[2]), &data);
    if (status) {
	unsigned type;

	status = 0;

	type = effect_type(data);
	if (type != lxtext_data->lxtype.code) {
	    l_MODE(0, output);
	} else {
	    X1f4_E4_C_USER user;

	    user = I_USER(byte(data) + 8);
	    if (lxtext_data->lxtype.copy && lxtext_data->lxtype.push) {
		status = _libx1f4i0_lxcall_side_node
		    (&lxtext_data->lxtype, user, input[0]);
		if (status) {
		} else {
		    l_MODE(1, output);
		}
	    } else {
		l_MODE(1, output);

		l_USER(user, input[0]);
	    }
	}
    } else {
	l_MODE(0, output);
    }

    return status;
}
