/*
 * lxlist-v.e.b.c
 * Copyright (C) 2008-2011, 2013-2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_list.h>
#include <lxlist-drive.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>

#define I_LIST(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_USER(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxlist_ebclass_v(void *context, void *output, void **input)
{
    int status;
    struct dxlist_type *dxlist_data;
    struct lxtext_type *lxtext_data;

    lxtext_data = context;

    dxlist_data = I_LIST(input[1]);
    if (0) {
    } else {
	unsigned size;

	size = dxlist_data->size;
	if (!size) {
	    status = _libx1f4i0_lxlist_stat_null(lxtext_data->text);
	} else {
	    void *data;

	    status = _libx1f4i0_ever_l4list(dxlist_data->list, &data);
	    if (status) {
		status =
		    _libx1f4i0_lxlist_stat_list(lxtext_data->text, 0, status);
	    } else {
		unsigned type;

		type = effect_type(data);
		if (type != lxtext_data->lxtype.code) {
		    status = _libx1f4i0_lxlist_stat_type
			(lxtext_data->text, size - 1, type,
			 lxtext_data->lxtype.code);
		} else {
		    status = lxtext_data->lxtype.push
			(lxtext_data->lxtype.context, input[0],
			 I_USER(byte(data) + 8), lock_excase(dxlist_data));
		    if (status) {
		    } else {
			byte(data)[4] = ~0 >> 030;
			byte(data)[5] = ~0 >> 020;
			byte(data)[6] = ~0 >> 010;
			byte(data)[7] = ~0 >> 000;

			--size;

# if defined __MISSING_SLIP_L_LIST__
			status = _libx1f4i0_miss_l4list
			    (dxlist_data->list, size);
# else
			status = _libx1f4i0_slip_l4list(dxlist_data->list);
# endif				/* __MISSING_SLIP_L_LIST__ */
			if (status) {
			    status = _libx1f4i0_lxlist_stat_list
				(lxtext_data->text, 0, status);
			} else {
			    dxlist_data->size = size;

			    l_USER(I_USER(*input), output);
			}
		    }
		}
	    }
	}
    }

    return status;
}
