/*
 * lxport-a.1.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <lxport-defs.h>
#include <lxport-inter.h>
#include <lxport-types.h>

static int fini_data(struct lxport_type *);

static int
fini_data(struct lxport_type *lxport_data)
{
    int (*free) (void *, void *), status;
    void *data;

    data = lxport_data->link_w.data;
    free = lxport_data->link_w.free;

    status = free(data, lxport_data->link_f.data);
    if (status) {
	status = FREE_ERROR;
    } else {
	status = free(data, lxport_data);
	if (status) {
	    status = FREE_ERROR;
	}
    }

    return status;
}


static int
lose_list(struct lxport_type *lxport_data)
{
    int excess, status = 0;
    struct waitlink_type *waitlink_data;

    waitlink_data = lxport_data->link_u.wait;
    while (waitlink_data) {
	void *waitlink;

	waitlink = waitlink_data;

	waitlink_data = waitlink_data->waitlink_next;

	excess = _libx1f4i0_lxport_lose_link(lxport_data, NULL, waitlink);
	if (excess) {
	    if (status) {
	    } else {
		status = excess;
	    }
	}
    }

    return status;
}


int
x1f4_fini_lxport(void **lxport)
{
    int excess, status;
    struct lxport_type *lxport_data;

    lxport_data = *lxport;

    status = lose_list(lxport_data);

    excess = fini_data(lxport_data);
    if (excess) {
	if (status) {
	} else {
	    status = excess;
	}
    }

    return status;
}
