/*
 * qscc.y.c
 * Copyright (C) 2010-2011, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <qscc-defs.h>
#include <qscc-inter.h>
#include <qscc-names.h>
#include <qscc-types.h>

#define qsrate(qsrate)			((struct qsrate_type *) (qsrate))

int
_libx1f4l2_ceil_qsrate(void *qsrate)
{
    int status;
    unsigned rate;

    rate = qsrate(qsrate)->link_a.fplist.rate;
    if (rate) {
	void *node;

	node = qsrate(qsrate)->link_a.fplist.fpnode;
	status = _libx1f4l2_gate_qsrate
	    (qsrate, node, rate - 1, 1 << qsrate(qsrate)->link_a.fplist.lock);
    } else {
	status = 0;
    }

    if (qsrate(qsrate)->link_e.fplink_data) {
	if (_libx1f4l2_fade_qsrate(qsrate)) {
	    if (status) {
	    } else {
		status = FREE_ERROR;
	    }
	}
    }

    if (qsrate(qsrate)->link_e.fplink_text) {
	if (_libx1f4l2_unit_qsrate(qsrate)) {
	    if (status) {
	    } else {
		status = FREE_ERROR;
	    }
	}
    }

    return status;
}
